<?php

class bCaracteristique_valeur extends BackModule {

    function bCaracteristique_valeur($formvars = array()) {
        parent::BackModule($formvars);
    }

    function update($formvars = array(), $table = null, $langue = true) {
        return parent::update_multi($formvars, $table, $langue);
    }

    function create($formvars = array(), $table = null, $langue = true) {
        return parent::create_multi($formvars, $table, $langue);
    }

    function delete($formvars = array(), $table = null, $langue = true) {
        return parent::delete_multi($formvars, $table, $langue);
    }

    function Form($formvars = array()) {

        // SQL
        if (!empty($formvars['id'])) {
            $this->request = getTableMutli('caracteristique_valeur', $formvars['id']);
        }
        //-- SQL
        // Champs du formulaire
        $form = new BackForm("caracteristique ID", "hidden", "caracteristique_id");
        $this->addForm($form);

        $form = new BackForm("Nom", "text", "caracteristique_valeur_nom_nom");
        $form->addAttr('class', 'required');
        $form->setVar('translate', true);
        $form->addAttr('size', 20);
        $this->addForm($form);

		$form = new BackForm("Visible dans le filtre", "select", "caracteristique_valeur_visible_filtre");
        $form->addOptionSQL(array("(SELECT 0, 'Non') UNION (SELECT 1, 'Oui')"));
        $this->addForm($form);

        $form = new BackForm("Rang", "text", "caracteristique_valeur_rang");
        $form->addAttr('class', 'required');
        $this->addForm($form);

        //GROUP
        $form = new BackForm("Informations couleur", "group");
        $this->addForm($form);
        //--GROUP

        $form = new BackForm("Code hexa", "text", "caracteristique_valeur_nom_image");
        $this->addForm($form);

        //-- Champs du formulaire
        if (!isset($formvars['id']))
            $formvars['id'] = 0;
        return $this->displayForm($formvars['id']);
    }

    function Listing($formvars = array()) {

        // SQL
        $sql = "SELECT cv.caracteristique_valeur_id, cv.caracteristique_valeur_id, cvn.caracteristique_valeur_nom_nom, caracteristique_valeur_rang";
        $sql.= " , IF(cv.caracteristique_valeur_visible_filtre = 1, 'Oui', 'Non')";
        $sql.=" FROM (caracteristique_valeur cv)";
        $sql.=" LEFT JOIN caracteristique_valeur_nom cvn ON (cvn.caracteristique_valeur_id = cv.caracteristique_valeur_id AND langue_id ='" . LANGUE . "')";
        $sql.=" WHERE 1";
        if (!empty($formvars['caracteristique']))
            $sql.=" AND cv.caracteristique_id = '" . $formvars['caracteristique'] . "'";
        $this->limit = 0;
        $this->request = $sql;
        //-- SQL
        // LABELS
        $label = new BackLabel("ID");
        $this->addLabel($label);

        $label = new BackLabel("NOM");
        $this->addLabel($label);

        $label = new BackLabel("RANG");
        $this->addLabel($label);
        
        $label = new BackLabel("VISIBLE DANS LE FILTRE");
        $this->addLabel($label);

        //-- LABELS

        return $this->displayList($formvars['type']);
    }

    function autocomplete($formvars = array()) {
        $out = "";
        if (isset($formvars['caracteristique_valeur_nom_nom']) && !empty($formvars['caracteristique_valeur_nom_nom']) && strlen($formvars['caracteristique_valeur_nom_nom']) > 0) {
            $cara = new Caracteristique();
            $arrCaraValeur = $cara->getValeur(array('search' => $formvars['caracteristique_valeur_nom_nom']));
            $i = 1;
            foreach ($arrCaraValeur as $val) {
                $out.="<input style='display:none;' id='input_caracteristiquevaleur_" . $val['caracteristique_valeur_id'] . "' value='" . $val['caracteristique_valeur_nom_nom'] . "'/>";
                $value = $val['caracteristique_nom_nom'] . " - " . $val['caracteristique_valeur_nom_nom'];
                $value = mb_eregi_replace("(" . $formvars['caracteristique_valeur_nom_nom'] . ")", "<strong>\\1</strong>", $value);
                $out .="<div class='results " . (($i) ? 'highlight' : '') . "' id='caracteristiquevaleur_" . $val['caracteristique_valeur_id'] . "'>" . $value . "</div>";
                $i = abs($i - 1);
            }

            if (!$out)
                $out = "<div>Entrez le nom d'une caracteristique</div>";
        }
        else
            $out = "<div>Entrez le nom d'une caracteristique</div>";

        return $out;
    }

    function getAutocomplete($formvars = array()) {
        $cara = new Caracteristique();
        list($arrArt) = $cara->getValeur(array('caracteristique_valeur_id' => $formvars['id']));

        return htmlentities($arrArt['caracteristique_valeur_nom_nom'], ENT_QUOTES, 'UTF-8') . "|" . $arrArt['caracteristique_valeur_id'];
    }

//--
}