<?php

// load lib
require __DIR__ . '/../vendor/autoload.php';

(new Dotenv\Dotenv(__DIR__.'/../'))->load();

ini_set('mbstring.language', 'UTF-8');
ini_set('mbstring.internal_encoding', 'UTF-8');
ini_set('mbstring.http_input', 'UTF-8');
ini_set('mbstring.http_output', 'UTF-8');
ini_set('mbstring.detect_order', 'auto');
/**
 * Config PHP
 */
if (!defined('DS')) {
    define('DS', DIRECTORY_SEPARATOR);
}

//définition du dossier www
if (!defined('ROOT')) {
    define('ROOT', dirname(dirname(dirname(__FILE__))));
}

//définition du dossier de l'application
if (!defined('APP_DIR')) {
    define('APP_DIR', basename(dirname(dirname(__FILE__))));
}

//définition du dossier ou site
if (!defined('SITE_DIR')) {
    define('SITE_DIR', ROOT . DS . APP_DIR . DS);
}

if (!defined('BACK_DIR')) {
    define('BACK_DIR', SITE_DIR . 'back' . DS);
}

if (!defined('MEDIA_DIR')) {
    define('MEDIA_DIR', SITE_DIR . 'media' . DS);
}

if (!defined('STORAGE_DIR')) {
    define('STORAGE_DIR', SITE_DIR . 'storage' . DS);
}

if (!defined('LOGS_DIR')) {
    define('LOGS_DIR', STORAGE_DIR . 'logs' . DS);
}

if (empty($_SERVER['HTTP_HOST'])) {
    $_SERVER['HTTP_HOST'] = getenv('APP_URL');
}

if (!defined('SITE_URL') && !empty($_SERVER['HTTP_HOST'])) {
    define('SITE_URL', 'http://' . $_SERVER['HTTP_HOST'] . '/');
}

define('BACK_URL', SITE_URL . 'back/');

// AUTHOR
define('AUTHOR_NAME', 'Dedi Agency');
define('AUTHOR_URL', 'http://www.dedi-agency.com/');
define('AUTHOR_MAIL_SUPPORT', 'support@dedi-agency.com');

define('DELAI_PAR_DEFAUT', 2); // delai de livraison par defaut en nombre de jours

// Register route annotation of Symfony component routing
\Doctrine\Common\Annotations\AnnotationRegistry::registerFile(
    __DIR__ . '/../vendor/symfony/routing/Annotation/Route.php'
);

Application::bootIfNotBooted();
