<?php

use Symfony\Component\EventDispatcher\Event;

// TODO : vider cette class et utiliser l'event Event\TemplateEvent::PRE_RENDER pour faire tout ce qui se fait ici !
// TODO : utiliser la balise render pour afficher les elements de la page : panier rollover, etc...

class Common {

    /**
     * @var \SiteSmarty
     */
    protected $template;

    public function boot(Event $event)
    {

        $this->template = $event->getEngine();

        $phpCache = new \Cache\BoutiqueCache();
        $lgBoutique = Boutique::getInstance()->getLangue();

        $this->template->assign('lgBoutique', $lgBoutique);

        $lgId = $lgBoutique->id;

        $txtAll = $phpCache->get('texte_' . $lgId);
        if ($txtAll === false) {
            $texte = new Texte;
            $txtAll = $texte->getAll();
            $phpCache->create('texte_' . $lgId, $txtAll);
        } else {
            Texte::setAll($txtAll);
        }
        $this->template->assign('txt', $txtAll);

        $cms = new Cms();
        /*$arrReassurance = $cms->getPageAssoc(array('cms_menu_id' => 4));
        $this->template->assign('arrReassurance', $arrReassurance);*/

        $tracking = new Tracking;
        $tracking->get('getVisites', '', $this->template);

        $this->template->registerClass('Breadcrumb', 'Breadcrumb');

        $this->template->assign('themeFolder', '/' . Boutique::getInstance()->dossier);

        /**
         * TODO : START move in HeaderController
         */
        //recuperation element du panier


        // get langue
        $langue = new Langue();
        $this->template->assign('langues', $langue->get());

        // page contact
        $pContact = $cms->get(array('cms_page_id' => Cms::PAGE_CONTACT));
        if (!empty($pContact)) {
            $this->template->assign('pContact', $pContact[0]);
        }

        $pagesTopRight = $phpCache->get('pages_top_right_' . $lgId);
        if ($pagesTopRight === false) {
            $pagesTopRight = $cms->get(array('cms_menu_id' => Cms::M_TOP_RIGHT));
            $phpCache->create('pages_top_right_' . $lgId, $pagesTopRight);
        }
        $this->template->assign('pagesTopRight', $pagesTopRight);

        /**
         * TODO : END move in HeaderController
         */

        $referencement = new Referencement;
        $formvars = array();
        $nfoUrl = explode('?', $_SERVER['REQUEST_URI']);
        $formvars['referencement_url'] = addslashes($nfoUrl[0]);
        $arrRef = $referencement->get($formvars);
        $ref = array();
        if(!empty($arrRef[0]['referencement_baseline'])) $ref['baseline'] = $arrRef[0]['referencement_baseline'];
        if(!empty($arrRef[0]['referencement_meta_title'])) $ref['title'] = $arrRef[0]['referencement_meta_title'];
        if(!empty($arrRef[0]['referencement_meta_desc'])) $ref['description'] = $arrRef[0]['referencement_meta_desc'];
        if(!empty($arrRef[0]['referencement_meta_kw'])) $ref['keywords'] = $arrRef[0]['referencement_meta_kw'];
        if(!empty($arrRef[0]['referencement_meta_other'])) $ref['other'] = $arrRef[0]['referencement_meta_other'];
        $this->template->assign('superRef',$ref);

    }
}