<?php

namespace Controller;

use Cache\BoutiqueCache;
use Boutique;
use Categorie;
use Cms;
use Exception;
use Gamme;
use Listing;
use Tools;

/**
 * Class FooterController
 *
 * @package Controller
 */
class FooterController extends Controller
{

    /**
     * @return \Symfony\Component\HttpFoundation\Response
     */
    public function display()
    {
        /*
        $cms = new Cms;
        $phpCache = new BoutiqueCache();

        $boutique = Boutique::getInstance();
        $lgId = $boutique->getLangue()->id;

        $arrFooter = $phpCache->get('arrFooter_'. $lgId . '_' . $boutique->id);
        if ($arrFooter === false) {
            $cms_pos = $cms->getPosition(array('menu_position_id' => Cms::POSITION_FOOTER));
            $arrFooter = array();

            foreach ($cms_pos as $row) {
                $arrFooter[$row['cms_menu_id']] = $row;
                $arrFooter[$row['cms_menu_id']]['pages'] = $cms->getMenu(['menu_position_id' => $row['cms_menu_id']]);
            }
            $phpCache->create('arrFooter_'. $lgId . '_' . $boutique->id, $arrFooter);
        }

        $this->template->assign('arrFooter', $arrFooter);

        //récupère les crédits
        $arrCredits = $cms->getMenu(array('menu_position_id' => Cms::M_CREDITS));
        $this->template->assign('arrCredits', $arrCredits);
        */

        $texte = new \Texte();
        $demande_catalogue_html = $texte->getOne('demande_catalogue_html');
        $this->template->assign('demande_catalogue_html', $demande_catalogue_html);

        try {
            $config = Boutique::getInstance()->getConfig('social');
            $this->template->assign('social', $config);
        } catch (Exception $e) {

        }

        return $this->fetch('parts/footer.tpl');
    }

    /**
     * @return \Symfony\Component\HttpFoundation\Response
     *
     * @throws \Exception
     * @throws \SmartyException
     */
    public function promosMoment()
    {
        // get promotions du moment
        $promosMoment = (new Listing())
            ->addGamme(new Gamme(Gamme::PROMOTIONS_MOMENT))
            ->setLimit(3)
            ->setOrder('random')
            ->getProductsToDisplay();
        $this->template->assign('promosMoment', $promosMoment);

        return $this->fetch('inc/promos_moment.tpl');
    }

    /**
     * @return \Symfony\Component\HttpFoundation\Response
     *
     * @throws \Exception
     * @throws \SmartyException
     */
    public function reinsurance()
    {
        /*$cms = new Cms();
        $arrReassurance = $cms->getPageAssoc(array('cms_menu_id' => Cms::M_REASSURANCE));
        $this->template->assign('arrReassurance', $arrReassurance);

        // recup page qui sommes nous
        $pQsn = $cms->get(array('cms_page_id' => Cms::PAGE_QSN));
        if (!empty($pQsn)) {
            $this->template->assign('pQsn', $pQsn[0]);
        }

        // get footer cms block pages
        $arrBlock = $cms->get(array("cms_menu_id" => Cms::M_BLOC_FOOTER));
        $this->template->assign("arrBlock", $arrBlock);

        $links = array();
        try{
            $links["social"] = Boutique::getInstance()->getConfig("social");
        } catch (Exception $e){
            Tools::dediLog($e->getMessage());
        }
        $this->template->assign("shoplinks", $links);
        */
        return $this->fetch('parts/reinsurance.tpl');
    }

    public function bottomLinks()
    {
        $categorie = new Categorie();
        $cats = $categorie->get(array("categorie_boutique_show_footer" => 1));
        $cats = array_slice($cats, 0, 15);

        $colClass = count($cats) > 5 ? (count($cats) > 10 ? "3" : "6") : "9";

        $tpl = array(
            "catByCol" => 5,
            "catColClass" => $colClass,
            "categoryLinks" => $cats,
        );

        return $this->fetch('parts/bottomLinks.tpl', $tpl);
    }
}
