<?php

/**
 * Class Devise
 */
class Devise extends Model {

    const D_DEFAULT = 1;

    protected $table = 'devise';

    public $id;
    public $nom;
    public $taux;
    public $emplacement;
    public $code;
    public $codeIso;

    public function __construct($id = null)
    {
        parent::__construct();

        if(!is_null($id)) {
            $this->load($id);
        }
    }

    public function load($id)
    {
        $theDevise = $this->get(array('devise_id' => $id));
        if(!empty($theDevise)) {
            $this->id = $theDevise[0]['devise_id'];
            $this->nom = $theDevise[0]['devise_nom'];
            $this->taux = $theDevise[0]['devise_taux'];
            $this->emplacement = $theDevise[0]['devise_emplacement'];
            $this->code = $theDevise[0]['devise_code'];
            $this->codeIso = $theDevise[0]['devise_code_iso'];
        }
    }

    /**
     * @param $price
     * @param $type
     * @param $decorate
     *
     * @return string
     */
    public function format($price, $type = 'ttc', $decorate = "text-14")
    {
        if (empty($this->id)) {
            $this->load(self::D_DEFAULT);
        }

        $strPrice = round($price * $this->taux, 2);
        $strPrice = number_format($strPrice, 2, ',', ' ');

        if ($decorate === false) {
            $span1 = $span2 = "";
        } else {
            $span1 = '<span class="'.$decorate.'">';
            $span2 = '</span>';

            $arrStrPrice = explode(',', $strPrice);
            $arrStrPrice[1] = $span1 . $arrStrPrice[1] . $span2;
            $strPrice = implode(',', $arrStrPrice);
        }

        if ($this->emplacement == 1) {
            $strPrice = $strPrice . ' ' . $span1 . $this->code . $span2;
        } elseif ($this->emplacement == 2) {
            $strPrice = $span1 . $this->code . $span2 . ' ' . $strPrice;
        }

        return $strPrice . ' ' . $span1 . $type . $span2;
    }

    /**
     *
     */
    public static function handle()
    {
        // TODO : session a revoir
        if (!empty($_GET['devise_id'])) {
            $deviseId = $_GET['devise_id'];
        } elseif (!empty($_SESSION['devise_id'])) {
            $deviseId = $_SESSION['devise_id'];
        }

        if (!empty($deviseId)) {
            $boutique = Boutique::getInstance();
            $boutique->getDevise()->load($deviseId);
        }
    }
}
