<?php

/**
 * Class Error
 */
class Error implements Iterator, Countable {

    private $_position = 0;
    private $_array = array();
    private $_texte = null;

    public function __construct() {
        $this->_position = 0;
        $this->_texte = new Texte();
    }

    public static function have() {
        return !empty($_SESSION['error']);
    }

    public static function get() {
        if (self::have()) {
            return unserialize($_SESSION['error']);
        }
    }

    public static function flush() {
        if (self::have()) {
            unset($_SESSION['error']);
        }
    }

    public function add($code) {
        $arrTexte = $this->_texte->getOne($code);
        if (!empty($arrTexte)) {
            $this->_array[] = $arrTexte;
        } else {
            $this->_array[] = $code;
        }
    }

    public function addTexte($str) {
        $this->_array[] = $str;
    }

    public function current() {
        return $this->_array[$this->_position];
    }

    public function key() {
        return $this->_position;
    }

    public function next() {
        ++$this->_position;
    }

    public function rewind() {
        $this->_position = 0;
    }

    public function reset(){
        $this->_array = array();
    }

    public function valid() {
        return isset($this->_array[$this->_position]);
    }

    public function count() {
        return count($this->_array);
    }

    /* public function __destruct() {
      $_SESSION['error'] = serialize($this);
      } */

    public function save() {
        $_SESSION['error'] = serialize($this);
    }

    public function getHTML() {
        if (!empty($this->_array)) {
            $html = '<ul class="error">';
            foreach ($this->_array as $a) {
                $html .= "<li>" . $a . "</li>";
            }
            $html .= "</ul>";
        } else {
            $html = false;
        }
        return $html;
    }

}

?>
