<?php

namespace Form\Constraint;

use DateTime;

/**
 * Class Date
 * @package Form\Constraint
 */
class Date extends Constraint
{
    /**
     * Awaited format
     * @var string
     */
    protected $format;

    /**
     * @param $format
     */
    public function __construct($format)
    {
        parent::__construct();
        $this->setFormat($format);
    }

    /**
     * @param $value
     * @return bool
     */
    public function isValid($value)
    {
        $date = DateTime::createFromFormat($this->getFormat(), $value);
        return $date && $date->format($this->getFormat()) == $value;
    }

    /**
     * @return mixed
     */
    public function getFormat()
    {
        return $this->format;
    }

    /**
     * @param mixed $format
     */
    public function setFormat($format)
    {
        $this->format = $format;
    }
}