<?php

namespace Form;

use Symfony\Component\HttpFoundation\Request;

abstract class Form
{

    /**
     * @var Request
     */
    protected $request;
    /**
     * @var Field[]
     */
    protected $fields;

    public function __construct()
    {
        $this->fields = array();
    }

    private function isValid()
    {
        $result = array();
        foreach ($this->fields as $field) {
            $haveError = $field->isValid($this->request);

            if (!empty($haveError)) {
                $result[$field->getName()] = $haveError;
            }
        }

        return $result;
    }

    public function add(Field $field)
    {
        $this->fields[] = $field;
        return $this;
    }

    public function handle(Request $request)
    {
        $this->request = $request;
        return $this->isValid();
    }

    public function render()
    {
        // TODO : show form
    }

}