<?php

/**
 * Class Marque
 *
 * @property integer $marque_id
 * @property string $marque_nom
 * @property string $marque_image
 * @property string $marque_nom_desc
 * @property string $marque_nom_desc_court
 * @property integer $marque_statut_id
 */
class Marque extends Model {

    protected $table = 'marque';

    function get($formvars = array(), $champs = "") {

        $sql = "SELECT *";
        $sql .= " FROM (marque m)";
        if(empty($formvars['no_boutique'])) {
            $sql .= " INNER JOIN marque_boutique mb ON(m.marque_id = mb.marque_id AND mb.boutique_id = '".Boutique::getInstance()->id."')";
        }
        $sql .= " LEFT JOIN marque_nom mn ON(m.marque_id = mn.marque_id AND mn.langue_id = '" . Boutique::getInstance()->getLangue()->id . "')";
        $sql .= " LEFT JOIN produit p ON(m.marque_id = p.marque_id)";

        if (!empty($formvars['with_cara'])) {
            $sql.=" LEFT JOIN caracteristique_valeur_nom cvn ON (cvn.caracteristique_valeur_nom_nom = m.marque_nom AND cvn.langue_id='".Boutique::getInstance()->getLangue()->id."')";
            $sql.=" LEFT JOIN caracteristique_valeur cv ON (cv.caracteristique_valeur_id = cvn.caracteristique_valeur_id)";
            $sql.=" LEFT JOIN caracteristique_nom caran ON (cv.caracteristique_id = caran.caracteristique_id AND caran.langue_id='".Boutique::getInstance()->getLangue()->id."')";
            $sql.=" LEFT JOIN caracteristique cara ON (cv.caracteristique_id = cara.caracteristique_id)";
        }

        if (!empty($formvars['categorie_id'])) {
            $sql.= " LEFT JOIN produit_categorie pc ON(p.produit_id = pc.produit_id)";
        }
        if (!empty($formvars['parent_id'])) {
            $sql.= " LEFT JOIN produit_categorie pc ON(p.produit_id = pc.produit_id)";
            $sql.= " LEFT JOIN categorie cc ON(pc.categorie_id = cc.categorie_id)";
            $sql.= " LEFT JOIN categorie ccpapa ON(ccpapa.categorie_id = cc.parent_id)";
        }
        if (!empty($formvars['categorie_ext_id'])) {
            $sql.= " LEFT JOIN produit_categorie pc ON(p.produit_id = pc.produit_id)";
            $sql.= " LEFT JOIN categorie c ON(c.categorie_id = pc.categorie_id)";
        }

        if (!empty($formvars['gamme'])) {
            $sql .= " LEFT JOIN produit_gamme pg ON(p.produit_id = pg.produit_id)";
        }

        $sql.=" WHERE 1";
        if(empty($formvars['no_boutique'])) {
            $sql.=" AND mb.marque_boutique_statut_id = 1";
        }
        $sql.=" AND p.produit_statut_id = 1";

        if (empty($formvars['no_boutique']) && isset($formvars['show_menu'])) {
            $sql.= " AND marque_boutique_show_menu = '".$formvars['show_menu']."'";
        }

        if (!empty($formvars['marque_id']))
            $sql.=" AND m.marque_id = '" . $formvars['marque_id'] . "'";
        if (!empty($formvars['image']))
            $sql.=" AND m.marque_image <> ''";
        if (isset($formvars['marque_statut_id']))
            $sql.=" AND m.marque_statut_id = '" . $formvars['marque_statut_id'] . "'";
        if (!empty($formvars['categorie_id']))
            $sql.=" AND pc.categorie_id = '" . $formvars['categorie_id'] . "'";
        if (!empty($formvars['parent_id']))
            $sql.=" AND (cc.parent_id = '" . $formvars['parent_id'] . "' OR ccpapa.parent_id = '" . $formvars['parent_id'] . "')";
        if (!empty($formvars['categorie_ext_id']))
            $sql .= " AND FIND_IN_SET(" . $formvars['categorie_ext_id'] . ",c.categorie_ext_id)";
        if (!empty($formvars['gamme']))
            $sql .= " AND pg.gamme_id IN (" . $formvars['gamme'] . ")";
        $sql.=" GROUP BY m.marque_id";


        if (!empty($formvars['order'])) {
            switch ($formvars['order']) {
                case 'random':
                    $sql.=" ORDER BY RAND()";
                    break;

                default:
                    $sql.=" ORDER BY marque_nom";
                    break;
            }
        } else {
            $sql.=" ORDER BY marque_nom";
        }

        if (!empty($formvars['limit'])) {
            $sql.=" LIMIT " . $formvars['limit'];
        }

        if (empty($champs)) {
            return $this->sql->getAll($sql);
        } else {
            $result = $this->sql->getOne($sql);
            return $result[$champs];
        }
    }
}