<?php

namespace Module;

class ModuleLoader {

    /**
     * @var Module[]
     */
    protected $modules;

    public function __construct()
    {
        $this->modules = array();
    }

    public function addModule(Module $module)
    {
        $this->modules[] = $module;
        return $this;
    }

    public function setModule($modules)
    {
        $this->modules = array_merge($this->modules, $modules);
        return $this;
    }

    public function load()
    {
        if (!empty($this->modules)) {
            foreach ($this->modules as $module) {
                $module->register();
            }
        }
    }
}