<?php

class PrixBarre extends Model{

    protected $table = "prix_barre";

    function get($formvars=array(), $champs = "") {

        $sql = "SELECT *";
        $sql.=" FROM prix_barre pb";
        if (!empty($formvars['boutique_id'])) {
            $sql.=" INNER JOIN prix_barre_boutique pbb ON(pb.prix_barre_id = pbb.prix_barre_id)";
        }
        $sql.=" WHERE 1";
        if (!empty($formvars['prix_barre_id']))
            $sql.=" AND pb.prix_barre_id = '" . $formvars['prix_barre_id'] . "'";
        if (!empty($formvars['boutique_id'])) {
            $sql.=" AND pbb.boutique_id = '" . $formvars['boutique_id'] . "'";
        }

        if (empty($champs)) {
            $this->sql->query($sql, SiteSQL::SQL_ALL, SiteSQL::SQL_ASSOC);
            return $this->sql->record;
        } else {
            $this->sql->query($sql, SiteSQL::SQL_INIT, SiteSQL::SQL_ASSOC);
            return $this->sql->record[$champs];
        }
    }

    // desaffecte les prix barres
    function deapply($prixBarreID, $boutiqueId = null) {

        $sql = "DELETE FROM produit_prix_barre WHERE prix_barre_id = '" . $prixBarreID . "'";
        if(!is_null($boutiqueId)) {
            $sql.=" AND boutique_id = '".$boutiqueId."'";
        }
        $this->sql->query($sql);
    }

    function getProduitByCategorie($prixBarreID, $boutiqueId = null) {

        // niveau 1
        $sql = "SELECT p.produit_id, pbc.prix_barre_categorie_inclus";
        $sql.=" FROM prix_barre_categorie pbc";
        $sql.=" INNER JOIN produit_categorie pc ON(pbc.categorie_id = pc.categorie_id)";
        $sql.=" INNER JOIN produit p ON(pc.produit_id = p.produit_id)";
        if(!is_null($boutiqueId)) {
            $sql.=" INNER JOIN produit_boutique pb ON(p.produit_id = pb.produit_id AND pb.boutique_id = '".$boutiqueId."')";
            $sql.=" INNER JOIN categorie_boutique cb ON(pc.categorie_id = cb.categorie_id AND cb.boutique_id = '".$boutiqueId."')";
        }
        $sql.=" WHERE p.produit_statut_id != 3";
        $sql.=" AND prix_barre_id = '" . $prixBarreID . "'";
        if(!is_null($boutiqueId)) {
            $sql.=" AND pb.produit_boutique_statut_id = 1";
            $sql.=" AND cb.categorie_boutique_statut_id = 1";
        }
        $sql.=" GROUP BY produit_id";
        $this->sql->query($sql, SiteSQL::SQL_ALL, SiteSQL::SQL_ASSOC);
        $niv1 = $this->sql->record;

        // niveau 2
        $sql = "SELECT p.produit_id, pbc.prix_barre_categorie_inclus";
        $sql.=" FROM prix_barre_categorie pbc";
        $sql.=" INNER JOIN categorie c ON(pbc.categorie_id = c.parent_id)";
        $sql.=" INNER JOIN produit_categorie pc ON(c.categorie_id = pc.categorie_id)";
        $sql.=" INNER JOIN produit p ON(pc.produit_id = p.produit_id)";
        if(!is_null($boutiqueId)) {
            $sql.=" INNER JOIN produit_boutique pb ON(p.produit_id = pb.produit_id AND pb.boutique_id = '".$boutiqueId."')";
            $sql.=" INNER JOIN categorie_boutique cb ON(pc.categorie_id = cb.categorie_id AND cb.boutique_id = '".$boutiqueId."')";
        }
        $sql.=" WHERE p.produit_statut_id != 3";
        $sql.=" AND prix_barre_id = '" . $prixBarreID . "'";
        if(!is_null($boutiqueId)) {
            $sql.=" AND pb.produit_boutique_statut_id = 1";
            $sql.=" AND cb.categorie_boutique_statut_id = 1";
        }
        $sql.=" GROUP BY produit_id";
        $this->sql->query($sql, SiteSQL::SQL_ALL, SiteSQL::SQL_ASSOC);
        $niv2 = $this->sql->record;

        $allProd = array_merge($niv1, $niv2);

        return $allProd;
    }

    function getProduitByGamme($prixBarreID, $boutiqueId = null) {

        // niveau 1
        $sql = "SELECT p.produit_id, pbg.prix_barre_gamme_inclus";
        $sql.=" FROM prix_barre_gamme pbg";
        $sql.=" INNER JOIN produit_gamme pg ON(pbg.gamme_id = pg.gamme_id)";
        $sql.=" INNER JOIN produit p ON(pg.produit_id = p.produit_id)";
        if(!is_null($boutiqueId)) {
            $sql.=" INNER JOIN produit_boutique pb ON(p.produit_id = pb.produit_id AND pb.boutique_id = '".$boutiqueId."')";
            $sql.=" INNER JOIN gamme_boutique gb ON(pg.gamme_id = gb.gamme_id AND gb.boutique_id = '".$boutiqueId."')";
        }
        $sql.=" WHERE p.produit_statut_id != 3";
        $sql.=" AND prix_barre_id = '" . $prixBarreID . "'";
        if(!is_null($boutiqueId)) {
            $sql.=" AND pb.produit_boutique_statut_id = 1";
            $sql.=" AND gb.gamme_boutique_statut_id = 1";
        }
        $sql.=" GROUP BY produit_id";
        $this->sql->query($sql, SiteSQL::SQL_ALL, SiteSQL::SQL_ASSOC);
        $allProd = $this->sql->record;

        return $allProd;
    }

    function getProduitByCollection($prixBarreID, $boutiqueId = null) {

        $sql = "SELECT p.produit_id, pbc.prix_barre_collection_inclus";
        $sql.=" FROM prix_barre_collection pbc";
        $sql.=" INNER JOIN produit p ON(p.produit_collection_id = pbc.collection_id)";
        if(!is_null($boutiqueId)) {
            $sql.=" INNER JOIN produit_boutique pb ON(p.produit_id = pb.produit_id AND pb.boutique_id = '".$boutiqueId."')";
        }
        $sql.=" WHERE p.produit_statut_id != 3";
        $sql.=" AND prix_barre_id = '" . $prixBarreID . "'";
        if(!is_null($boutiqueId)) {
            $sql.=" AND pb.produit_boutique_statut_id = 1";
        }
        $sql.=" GROUP BY produit_id";
        $this->sql->query($sql, SiteSQL::SQL_ALL, SiteSQL::SQL_ASSOC);
        $allProd = $this->sql->record;

        return $allProd;
    }

    function getProduitByFournisseur($prixBarreID, $boutiqueId = null) {

        // niveau 1
        $sql = "SELECT p.produit_id, pbf.prix_barre_fournisseur_inclus";
        $sql.=" FROM prix_barre_fournisseur pbf, produit p";
        if(!is_null($boutiqueId)) {
            $sql.=" INNER JOIN produit_boutique pb ON(p.produit_id = pb.produit_id AND pb.boutique_id = '".$boutiqueId."')";
            $sql.=" INNER JOIN fournisseur_boutique fb ON(p.fournisseur_id = fb.fournisseur_id AND fb.boutique_id = '".$boutiqueId."')";
        }
        $sql.=" WHERE pbf.fournisseur_id = p.fournisseur_id";
        $sql.=" AND p.produit_statut_id != 3";
        $sql.=" AND prix_barre_id = '" . $prixBarreID . "'";
        if(!is_null($boutiqueId)) {
            $sql.=" AND pb.produit_boutique_statut_id = 1";
            $sql.=" AND fb.fournisseur_boutique_statut_id = 1";
        }
        $sql.=" GROUP BY produit_id";
        $this->sql->query($sql, SiteSQL::SQL_ALL, SiteSQL::SQL_ASSOC);
        $allProd = $this->sql->record;

        return $allProd;
    }

    function getProduitByMarque($prixBarreID, $boutiqueId = null) {

        // niveau 1
        $sql = "SELECT p.produit_id, pbm.prix_barre_marque_inclus";
        $sql.=" FROM prix_barre_marque pbm, produit p";
        if(!is_null($boutiqueId)) {
            $sql.=" INNER JOIN produit_boutique pb ON(p.produit_id = pb.produit_id AND pb.boutique_id = '".$boutiqueId."')";
            $sql.=" INNER JOIN marque_boutique mb ON(p.marque_id = mb.marque_id AND mb.boutique_id = '".$boutiqueId."')";
        }
        $sql.=" WHERE pbm.marque_id = p.marque_id";
        $sql.=" AND p.produit_statut_id != 3";
        $sql.=" AND prix_barre_id = '" . $prixBarreID . "'";
        if(!is_null($boutiqueId)) {
            $sql.=" AND pb.produit_boutique_statut_id = 1";
            $sql.=" AND mb.marque_boutique_statut_id = 1";
        }
        $sql.=" GROUP BY produit_id";
        $this->sql->query($sql, SiteSQL::SQL_ALL, SiteSQL::SQL_ASSOC);
        $allProd = $this->sql->record;

        return $allProd;
    }

    function getProduitByProduit($prixBarreID, $boutiqueId = null) {

        // niveau 1
        $sql = "SELECT p.produit_id, pbp.prix_barre_produit_inclus";
        $sql.=" FROM prix_barre_produit pbp, produit p";
        if(!is_null($boutiqueId)) {
            $sql.=" INNER JOIN produit_boutique pb ON(p.produit_id = pb.produit_id AND pb.boutique_id = '".$boutiqueId."')";
        }
        $sql.=" WHERE pbp.produit_id = p.produit_id";
        $sql.=" AND p.produit_statut_id != 3";
        $sql.=" AND prix_barre_id = '" . $prixBarreID . "'";
        if(!is_null($boutiqueId)) {
            $sql.=" AND pb.produit_boutique_statut_id = 1";
        }
        $sql.=" GROUP BY produit_id";
        $this->sql->query($sql, SiteSQL::SQL_ALL, SiteSQL::SQL_ASSOC);
        $allProd = $this->sql->record;

        return $allProd;
    }

    function getBoutique($prixBarreID = "") {
        $sql = "SELECT b.boutique_id";
        $sql.=" FROM prix_barre_boutique pbb, boutique b";
        $sql.=" WHERE pbb.boutique_id = b.boutique_id";
        $sql.=" AND pbb.prix_barre_boutique_statut_id = 1";
        if(!empty($prixBarreID)){
            $sql.=" AND prix_barre_id = '" . $prixBarreID . "'";
        }
        $sql.=" GROUP BY boutique_id";
        $this->sql->query($sql, SiteSQL::SQL_ALL, SiteSQL::SQL_ASSOC);
        $boutiques = $this->sql->record;

        return $boutiques;
    }

    // on affecte les prix barres
    function apply($prixBarreID = "") {
        if (empty($prixBarreID)) {
            $arrPrixBarre = $this->get();
        } else {
            $arrPrixBarre = $this->get(array('prix_barre_id' => $prixBarreID));
        }

        #VENTES FLASH
        $keyFlashSales = 'flash_sales_id';
        $gammeConf = Boutique::getInstance()->getConfig('gamme', false);
        $etiquetteConf = Boutique::getInstance()->getConfig('etiquette', false);
        $q = new Query();

        if(isset($gammeConf[$keyFlashSales]) && isset($etiquetteConf[$keyFlashSales])) {
            $q->delete('produit_gamme')
                ->where('gamme_id = ' . $gammeConf[$keyFlashSales]);
            $result = $this->sql->query($q->build());
            if(!$result){
                throw new DediException('Truncate flash_sales error');
            }
        }
        #/VENTES FLASH

        #CARACTERISTIQUE REDUCTION
        $reductions = array();
        $keyCaracReduction = 'reduction_id';
        $caracConf = Boutique::getInstance()->getConfig('carac', false);
        $q = new Query();

        if(isset($caracConf[$keyCaracReduction])) {
            $caracReductionsValeurID = array();
            $q->select()
                ->from('caracteristique_valeur_nom')
                ->leftJoin('caracteristique_valeur cv ON cv.caracteristique_valeur_id = cvn.caracteristique_valeur_id')
                ->where('cv.caracteristique_id = ' . (int)$caracConf[$keyCaracReduction]);

            $caracReductionsValeurs = $this->sql->getAll($q->build());

            if (!empty($caracReductionsValeurs)) {
                foreach ($caracReductionsValeurs as $valeur) {
                    if (preg_match_all('#([0-9]+)%#', $valeur['caracteristique_valeur_nom_nom'], $matches)) {
                        $reductions[$valeur['caracteristique_valeur_id']] = array(
                            'min' => $matches[1][0],
                            'max' => $matches[1][1]
                        );
                    }
                    $caracReductionsValeurID[] = $valeur['caracteristique_valeur_id'];
                }
            }
            if (!empty($caracReductionsValeurID)) {
                $q->reset()
                    ->delete('produit_caracteristique_valeur')
                    ->where('caracteristique_valeur_id IN (' . implode(',', $caracReductionsValeurID) . ')');
                $result = $this->sql->query($q->build());
                if(!$result){
                  throw new DediException('Truncate reductions error');
                }
            }
        }
        #/CARACTERISTIQUE REDUCTION

        foreach ($arrPrixBarre as $prixBarre) {

            $this->deapply($prixBarre['prix_barre_id']);

            if ($prixBarre['prix_barre_statut_id'] != 1 || $prixBarre['prix_barre_date_fin'] < date('Y-m-d H:i:s')) {
                continue;
            }

            // recup des boutiques pour lesquelles le prix barré est actif
            $arrBoutique = $this->getBoutique($prixBarreID);

            foreach($arrBoutique as $bout) {

                $includeProd = array();
                $excludeProd = array();
                // $arrPromo = array();

                // on gere le cas "tous les produits"
                if ($prixBarre['prix_barre_all'] == 1) {
                    $sql = "SELECT p.produit_id";
                    $sql.= " FROM produit p";
                    $sql.= " INNER JOIN produit_boutique pb ON(p.produit_id = pb.produit_id AND pb.boutique_id = '".$bout['boutique_id']."')";
                    $sql.= " WHERE p.produit_statut_id != 3 AND pb.produit_boutique_statut_id = 1";
                    $this->sql->query($sql, SiteSQL::SQL_ALL, SiteSQL::SQL_ASSOC);
                    $arrProd = $this->sql->record;
                    foreach ($arrProd as $prod) {
                        array_push($includeProd, $prod['produit_id']);
                    }
                }

                // on gere les categories
                $arrProd = $this->getProduitByCategorie($prixBarre['prix_barre_id'], $bout['boutique_id']);
                if (!empty($arrProd)) {
                    foreach ($arrProd as $prod) {
                        if ($prod['prix_barre_categorie_inclus'] == 1)
                            array_push($includeProd, $prod['produit_id']);
                        else
                            array_push($excludeProd, $prod['produit_id']);
                    }
                }

                // on gere les gammes
                $arrProd = $this->getProduitByGamme($prixBarre['prix_barre_id'], $bout['boutique_id']);
                if (!empty($arrProd)) {
                    foreach ($arrProd as $prod) {
                        if ($prod['prix_barre_gamme_inclus'] == 1)
                            array_push($includeProd, $prod['produit_id']);
                        else
                            array_push($excludeProd, $prod['produit_id']);
                    }
                }

                // on gere les collections
                $arrProd = $this->getProduitByCollection($prixBarre['prix_barre_id'], $bout['boutique_id']);
                if (!empty($arrProd)) {
                    foreach ($arrProd as $prod) {
                        if ($prod['prix_barre_collection_inclus'] == 1)
                            array_push($includeProd, $prod['produit_id']);
                        else
                            array_push($excludeProd, $prod['produit_id']);
                    }
                }

                // on gere les fournisseurs
                $arrProd = $this->getProduitByFournisseur($prixBarre['prix_barre_id'], $bout['boutique_id']);
                if (!empty($arrProd)) {
                    foreach ($arrProd as $prod) {
                        if ($prod['prix_barre_fournisseur_inclus'] == 1)
                            array_push($includeProd, $prod['produit_id']);
                        else
                            array_push($excludeProd, $prod['produit_id']);
                    }
                }

                // on gere les marques
                $arrProd = $this->getProduitByMarque($prixBarre['prix_barre_id'], $bout['boutique_id']);
                if (!empty($arrProd)) {
                    foreach ($arrProd as $prod) {
                        if ($prod['prix_barre_marque_inclus'] == 1)
                            array_push($includeProd, $prod['produit_id']);
                        else
                            array_push($excludeProd, $prod['produit_id']);
                    }
                }

                // on gere les produits
                $arrProd = $this->getProduitByProduit($prixBarre['prix_barre_id'], $bout['boutique_id']);
                if (!empty($arrProd)) {
                    foreach ($arrProd as $prod) {
                        if ($prod['prix_barre_produit_inclus'] == 1)
                            array_push($includeProd, $prod['produit_id']);
                        else
                            array_push($excludeProd, $prod['produit_id']);
                    }
                }

                $includeProd = array_values(array_unique($includeProd));
                $excludeProd = array_values(array_unique($excludeProd));
                //var_dump($includeProd);
                //var_dump($excludeProd);

                $arrPromo = array_diff($includeProd, $excludeProd);

                // on insere en base
                foreach ($arrPromo as $promo) {

                    $sql = "SELECT produit_prix FROM produit WHERE produit_id = '" . $promo . "'";
                    $this->sql->query($sql, SiteSQL::SQL_INIT, SiteSQL::SQL_ASSOC);
                    $price = $this->sql->record['produit_prix'];

                    if ($prixBarre['prix_barre_prefix_id'] == 1) {
                        $produit_prix_barre_prix = $price - $prixBarre['prix_barre_prix'];
                    } else {
                        $produit_prix_barre_prix = $price - ($price * ($prixBarre['prix_barre_prix'] / 100));
                    }

                    if ($produit_prix_barre_prix < 0)
                        $produit_prix_barre_prix = 0;
                    if ($price == 0)
                        $produit_prix_barre_percent = 0;
                    else
                        $produit_prix_barre_percent = 100 - (($produit_prix_barre_prix / $price) * 100);
                    $produit_prix_barre_valeur = $price - $produit_prix_barre_prix;

                    // pour les attributs
                    if ($prixBarre['prix_barre_prefix_id'] == 1) {
                        $resteADeduire = $prixBarre['prix_barre_prix'] - ($price - $produit_prix_barre_prix);
                    }


                    $sql = "INSERT INTO produit_prix_barre SET";
                    $sql.=" produit_id = '" . $promo . "'";
                    $sql.=", prix_barre_id = '" . $prixBarre['prix_barre_id'] . "'";
                    if (empty($prixBarre['etiquette_id']))
                        $sql.=", etiquette_id = NULL";
                    else
                        $sql.=", etiquette_id = '" . $prixBarre['etiquette_id'] . "'";
                    $sql.=", produit_prix_barre_prix = '" . $produit_prix_barre_prix . "'";
                    $sql.=", produit_prix_barre_percent = '" . $produit_prix_barre_percent . "'";
                    $sql.=", produit_prix_barre_valeur = '" . $produit_prix_barre_valeur . "'";
                    $sql.=", produit_prix_barre_date_debut = '" . $prixBarre['prix_barre_date_debut'] . "'";
                    $sql.=", produit_prix_barre_date_fin = '" . $prixBarre['prix_barre_date_fin'] . "'";
                    $sql.=", boutique_id = '".$bout['boutique_id']."'";

                    $this->sql->query($sql);
                    $idPrixBarre = $this->sql->db->insert_id;

                    $priceProduit = $price;
                    $promoProduit = $produit_prix_barre_prix;
                    $topDiff = 0;
                    $topPer = 0;

                    $sql = "SELECT produit_attribut_prix, produit_attribut_id FROM produit_attribut WHERE produit_id = '" . $promo . "' AND produit_attribut_statut_id != 3";
                    //echo $sql;
                    $this->sql->query($sql, SiteSQL::SQL_ALL, SiteSQL::SQL_ASSOC);
                    $arrAtt = $this->sql->record;
                    foreach ($arrAtt as $att) {

                        if ($prixBarre['prix_barre_prefix_id'] == 1) {
                            // attribut on applique pas
                            $produit_prix_barre_prix = $att['produit_attribut_prix'] - $resteADeduire;
                        } else {
                            $produit_prix_barre_prix = $att['produit_attribut_prix'] - ($att['produit_attribut_prix'] * ($prixBarre['prix_barre_prix'] / 100));
                        }

                        if ($produit_prix_barre_prix < 0)
                            $produit_prix_barre_prix = 0;
                        if ($att['produit_attribut_prix'] == 0)
                            $produit_prix_barre_percent = 0;
                        else
                            $produit_prix_barre_percent = 100 - (($produit_prix_barre_prix / $att['produit_attribut_prix']) * 100);
                        $produit_prix_barre_valeur = $att['produit_attribut_prix'] - $produit_prix_barre_prix;


                        $sql = "INSERT INTO produit_prix_barre SET";
                        $sql.=" produit_id = '" . $promo . "'";
                        $sql.=", produit_attribut_id = '" . $att['produit_attribut_id'] . "'";
                        $sql.=", prix_barre_id = '" . $prixBarre['prix_barre_id'] . "'";
                        if (empty($prixBarre['etiquette_id']))
                            $sql.=", etiquette_id = NULL";
                        else
                            $sql.=", etiquette_id = '" . $prixBarre['etiquette_id'] . "'";
                        $sql.=", produit_prix_barre_prix = '" . $produit_prix_barre_prix . "'";
                        $sql.=", produit_prix_barre_percent = '" . $produit_prix_barre_percent . "'";
                        $sql.=", produit_prix_barre_valeur = '" . $produit_prix_barre_valeur . "'";
                        $sql.=", produit_prix_barre_date_debut = '" . $prixBarre['prix_barre_date_debut'] . "'";
                        $sql.=", produit_prix_barre_date_fin = '" . $prixBarre['prix_barre_date_fin'] . "'";
                        $sql.=", boutique_id = '".$bout['boutique_id']."'";
                        $this->sql->query($sql);

                        $prixTotal = $priceProduit + $att['produit_attribut_prix'];
                        $prixPromo = $promoProduit + $produit_prix_barre_prix;
                        $curDiff = $prixTotal - $prixPromo;
                        $curPer = (1 - ($prixPromo / $prixTotal)) * 100;
                        if ($topDiff < $curDiff)
                            $topDiff = $curDiff;
                        if ($topPer < $curPer)
                            $topPer = $curPer;
                    }

                    if (!empty($arrAtt)) {
                        $sql = "UPDATE produit_prix_barre SET produit_prix_barre_percent = '" . $topPer . "', produit_prix_barre_valeur = '" . $topDiff . "' WHERE produit_prix_barre_id = '" . $idPrixBarre . "'";
                        $this->sql->query($sql);
                    }

                    #VENTES FLASH
                    if(isset($gammeConf[$keyFlashSales]) && isset($etiquetteConf[$keyFlashSales])){
                        if(isset($prixBarre['etiquette_id']) && $prixBarre['etiquette_id'] == $etiquetteConf[$keyFlashSales]){
                            $q->reset()
                                ->insert('produit_gamme')
                                ->value('produit_id', $promo)
                                ->value('gamme_id', $gammeConf[$keyFlashSales]);
                            $result = $this->sql->query($q->build());
                        }
                    }
                    #/VENTES FLASH
                    #CARACTERISTIQUE REDUCTION
                    if(isset($caracConf[$keyCaracReduction]) && !empty($reductions)){
                        $actualReductionID = false;
                        foreach($reductions as $caracteristiqueValeurId => $reduction){
                            if((float)$curPer > (float)$reduction['min'] && (float)$curPer <= (float)$reduction['max']){
                                $actualReductionID = $caracteristiqueValeurId;
                                break;
                            }
                        }
                        if($actualReductionID){
                            $q->reset()
                                ->insert('produit_caracteristique_valeur')
                                ->value('produit_id', $promo)
                                ->value('caracteristique_valeur_id', $actualReductionID);
                            $result = $this->sql->query($q->build());
                        }
                    }
                    #/CARACTERISTIQUE REDUCTION
                }
            }
        }
    }

    function updateValeur($idPrixBarre) {

        $sql = "SELECT ppb.*, p.produit_prix, pa.produit_attribut_prix";
        $sql.=" FROM (produit_prix_barre ppb, produit p)";
        $sql.=" LEFT JOIN produit_attribut pa ON (pa.produit_attribut_id = ppb.produit_attribut_id)";
        $sql.=" WHERE p.produit_id = ppb.produit_id";
        $sql.=" AND ppb.produit_prix_barre_id = '" . $idPrixBarre . "'";

        $this->sql->query($sql, SiteSQL::SQL_INIT, SiteSQL::SQL_ASSOC);
        $zePrixbarre = $this->sql->record;

        if (!empty($zePrixbarre['produit_attribut_id'])) {
            $percent = ($zePrixbarre['produit_prix_barre_prix'] / ($zePrixbarre['produit_prix']+$zePrixbarre['produit_attribut_prix'])) * 100;
            $valeur = ($zePrixbarre['produit_prix']+$zePrixbarre['produit_attribut_prix']) - $zePrixbarre['produit_prix_barre_prix'];
        } else {
            $percent = ($zePrixbarre['produit_prix_barre_prix'] / $zePrixbarre['produit_prix']) * 100;
            $valeur = $zePrixbarre['produit_prix'] - $zePrixbarre['produit_prix_barre_prix'];
        }


        $sql = "UPDATE produit_prix_barre SET";
        $sql.=" produit_prix_barre_percent = '" . $percent . "'";
        $sql.=", produit_prix_barre_valeur = '" . $valeur . "'";
        $sql.=" WHERE produit_prix_barre_id = '" . $idPrixBarre . "'";

        $this->sql->query($sql);
    }

}