<?php

namespace Shopbydedi;

use Model;
use Boutique;
use Client;

/**
 * Class Attribut
 * @package Shopbydedi
 */
class Attribut extends Model
{
    /**
     * @var string
     */
    protected $table = 'produit_attribut';

    /**
     * @param array $formvars
     * @return array
     */
    public function getOne($formvars = array())
    {
        $result = $this->get($formvars);
        return (!empty($result)) ? $result[0] : array();
    }

    /**
     * @deprecated
     *
     * @param array $formvars
     * @param string $champs
     *
     * @return array
     */
    public function getBloc($formvars = array(), $champs = "")
    {
        return $this->get($formvars, $champs);
    }

    /**
     * @param array $formvars
     * @param string $champs
     * @return array
     */
    public function get($formvars = array(), $champs = "")
    {

        $lgId = Boutique::getInstance()->getLangue()->id;

        //$groupePrix = Client::getCurrentGroupePrix();

        $sql = "SELECT a.produit_attribut_id, a.produit_option_valeur_id, a.produit_option_valeur_id_bis";
        $sql .= ", a.produit_attribut_ref, a.produit_attribut_ref_frs, a.produit_option_valeur_desc";
        $sql.= ", a.produit_id, pn.produit_nom_nom";
        $sql.= ", IF(povnbis.produit_option_valeur_nom != '' && povn.produit_option_valeur_nom != '', CONCAT(povn.produit_option_valeur_nom,' & ',povnbis.produit_option_valeur_nom), IF(povnbis.produit_option_valeur_nom != '', povnbis.produit_option_valeur_nom, povn.produit_option_valeur_nom)) as produit_option_valeur_nom";

        $sql.=", pi.produit_image, pi.produit_image_id";
        $sql.=", poptn.produit_option_nom";

        // remonter des prix
        $sql.=", a.produit_attribut_prix_ecotaxe, (p.produit_prix + a.produit_attribut_prix) as produit_attribut_prix, a.produit_attribut_achat";
        $sql.=",a.produit_attribut_ean";

        // info type produit
        $sql.=", p.produit_type_id, pt.produit_type_stock, pt.produit_type_port, pt.produit_type_class";//, pt.produit_type_taxe";

        $sql.=",a.produit_attribut_conditionnement";
        $sql.=", o.produit_option_id";

        $sql.=", ROUND(MIN(a.produit_attribut_prix) + p.produit_prix,2) AS attribut_prix_ht";
        $sql.=", ROUND((MIN(a.produit_attribut_prix) + p.produit_prix) * (1 + taxe_taux),2) AS attribut_prix_ttc";

        $sql.=", IF(ppb_att.produit_prix_barre_id,MIN(ppb.produit_prix_barre_prix)+MIN(ppb_att.produit_prix_barre_prix),ROUND(MIN(a.produit_attribut_prix) + p.produit_prix,2)) AS attribut_produit_prix_ht";
        $sql.=", ROUND(IF(ppb_att.produit_prix_barre_id,MIN(ppb.produit_prix_barre_prix)+MIN(ppb_att.produit_prix_barre_prix),ROUND(MIN(a.produit_attribut_prix) + p.produit_prix,2)) * (1 + taxe_taux),2) AS attribut_produit_prix_ttc";

        $sql.=", ppb_att.produit_prix_barre_id AS attribut_promo";
        $sql.=", MAX(ppb_att.produit_prix_barre_percent) AS attribut_promo_percent";
        $sql.=", MAX(ppb.produit_prix_barre_valeur)+MAX(ppb_att.produit_prix_barre_valeur) AS attribut_promo_valeur_ht";
        $sql.=", ROUND((MAX(ppb.produit_prix_barre_valeur)+MAX(ppb_att.produit_prix_barre_valeur)) * (1 + taxe_taux),2) AS attribut_promo_valeur_ttc";
        //-- remonter des prix
        // info de stock
        $sql.=", a.produit_attribut_quantite, a.produit_attribut_livraison, a.produit_appro_id";
        $sql.=", a.produit_attribut_poids";

        if (empty($formvars['produit_attribut_quantite'])) {
            $formvars['produit_attribut_quantite'] = 1;
        }
        $sql.=", IF(a.produit_attribut_quantite-" . $formvars['produit_attribut_quantite'] . "<0,IF(a.produit_attribut_livraison,a.produit_attribut_livraison,IF(p.produit_livraison,p.produit_livraison,IF(f.fournisseur_livraison,f.fournisseur_livraison," . DELAI_PAR_DEFAUT . "))),0) as delai_livraison";
        $sql.=", IF(a.produit_appro_id=0 && a.produit_attribut_quantite<=0, 1, 0) as epuise";
        //-- info de stock
        // utile pour les tris
        $sql.=", povn.produit_option_valeur_nom as nom_att1";
        $sql.=", povnbis.produit_option_valeur_nom as nom_att2";

        $sql.=" FROM (produit_attribut a)";
        $sql.=" INNER JOIN produit p ON(p.produit_id = a.produit_id)";
        if (empty($formvars['no_boutique'])) {
            $sql.=" INNER JOIN produit_boutique pb ON(p.produit_id = pb.produit_id AND pb.boutique_id = '".Boutique::getInstance()->id."')";
        }
        $sql.=" INNER JOIN taxe t ON(p.taxe_id = t.taxe_id)";
        $sql.=" LEFT JOIN produit_type pt ON (pt.produit_type_id = p.produit_type_id)";

        $sql.=" LEFT JOIN produit_option_valeur o ON (o.produit_option_valeur_id = a.produit_option_valeur_id)";
        $sql.=" LEFT JOIN produit_option po ON (o.produit_option_id = po.produit_option_id)";
        $sql.=" LEFT JOIN produit_option_nom poptn ON (po.produit_option_id = poptn.produit_option_id AND poptn.langue_id='" . $lgId . "')";

        $sql.=" LEFT JOIN produit_option_valeur_nom povn ON (o.produit_option_valeur_id = povn.produit_option_valeur_id AND povn.langue_id='" . $lgId . "')";
        $sql.=" LEFT JOIN produit_option_valeur_nom povnbis ON (a.produit_option_valeur_id_bis = povnbis.produit_option_valeur_id AND povnbis.langue_id='" . $lgId . "')"; //multi att

        $sql.=" LEFT JOIN produit_option_nom pon ON (po.produit_option_id = pon.produit_option_id AND pon.langue_id='" . $lgId . "')";
        $sql.=" LEFT JOIN produit_nom pn ON (p.produit_id = pn.produit_id AND pn.langue_id='" . $lgId . "')";
        $sql.=" LEFT JOIN fournisseur f ON (p.fournisseur_id = f.fournisseur_id)";
        $sql.=" LEFT JOIN produit_image pi ON (p.produit_id = pi.produit_id)";

        $sql.=" LEFT JOIN produit_prix_barre ppb ON (p.produit_id = ppb.produit_id AND ppb.produit_attribut_id IS NULL AND ppb.produit_prix_barre_date_debut <= NOW() AND ppb.produit_prix_barre_date_fin >= NOW() AND ppb.boutique_id = '".Boutique::getInstance()->id."')";
        $sql.=" LEFT JOIN produit_prix_barre ppb_att ON (p.produit_id = ppb_att.produit_id AND ppb_att.produit_attribut_id = a.produit_attribut_id AND ppb_att.produit_prix_barre_date_debut <= NOW() AND ppb_att.produit_prix_barre_date_fin >= NOW() AND ppb_att.boutique_id = '".Boutique::getInstance()->id."')";


        // MILLESIMES
        //$sql.=" LEFT JOIN produit_attribut_prix pap ON(a.produit_attribut_id = pap.produit_attribut_id)";
        // AND pap.groupe_prix_id IN(".implode(',', $groupePrix).")
        //--

        $sql.=" WHERE 1";

        if (empty($formvars['no_boutique'])) {
            $sql.=" AND pb.produit_boutique_statut_id = 1";
        }

        if (empty($formvars['all'])) {
            $sql .= " AND a.produit_attribut_statut_id = '1'";
        }

        if (!empty($formvars['produit_id'])) {
            $sql .= " AND a.produit_id = '" . $formvars['produit_id'] . "'";
        }
        if (!empty($formvars['produit_attribut_id'])) {
            $sql .= " AND a.produit_attribut_id = '" . $formvars['produit_attribut_id'] . "'";
        }
        if (!empty($formvars['pa.produit_attribut_id'])) {
            $sql .= " AND a.produit_attribut_id = '" . $formvars['pa.produit_attribut_id'] . "'";
        }

        if (!empty($formvars['produit_option_valeur_id'])) {
            $sql .= " AND a.produit_option_valeur_id = '" . $formvars['produit_option_valeur_id'] . "'";
        }
        if (!empty($formvars['produit_option_valeur_id_bis'])) {
            $sql .= " AND a.produit_option_valeur_id_bis = '" . $formvars['produit_option_valeur_id_bis'] . "'";
        }

        if (!empty($formvars['produit_attribut_conditionnement'])) {
            if (is_array($formvars['produit_attribut_conditionnement'])) {
                if (isset($formvars['produit_attribut_conditionnement'][0])) {
                    $sql .= " AND a.produit_attribut_conditionnement <= '" . $formvars['produit_attribut_conditionnement'][0] . "'";
                }
                if (isset($formvars['produit_attribut_conditionnement'][1])) {
                    $sql .= " AND a.produit_attribut_conditionnement >= '" . $formvars['produit_attribut_conditionnement'][1] . "'";
                }
            } else {
                $sql .= " AND a.produit_attribut_conditionnement = '" . $formvars['produit_attribut_conditionnement'] . "'";
            }
        }

        $sql.=" GROUP BY a.produit_attribut_id";

        if (empty($formvars['order'])) {
            $formvars['order'] = '';
        }
        switch ($formvars['order']) {
            case "conditionnement":
                $sql.=" ORDER BY produit_attribut_conditionnement DESC";
                break;
            default:
                $sql.=" ORDER BY produit_attribut_rang,produit_option_rang, nom_att1, nom_att2";
                break;
        }

        //dump($sql);
        if (empty($champs)) {
            return $this->sql->getAll($sql);
        } else {
            $result = $this->sql->getOne($sql);
            return $result[$champs];
        }
    }
}
