<?php

/**
 * Class Template
 */
class Template {

    /**
     * @var Template
     */
    static private $_instance = null;
    /**
     * @var SiteSmarty
     */
    public $templateObject = null;

    private function __construct() {
        
    }

    /**
     * @return SiteSmarty
     */
    public static function getInstance() {
        if (!(self::$_instance instanceof self)) {
            self::$_instance = new self();
        }

        return self::$_instance;
    }

    /**
     * @param $moteur
     * @return SiteSmarty
     */
    public static function create($moteur) {
        $templateMoteur = self::getInstance();

        if (is_null($templateMoteur->templateObject)) {
            switch ($moteur) {
                case 'smarty':
                    $templateMoteur->templateObject = new SiteSmarty();
                    break;
            }
        }
        return self::$_instance;
    }

    /**
     * @param $name
     * @return mixed
     */
    public function __get($name) {
        return $this->templateObject->$name;
    }

    /**
     * @param $name
     * @param $value
     */
    public function __set($name, $value) {
        $this->templateObject->$name = $value;
    }

    /**
     * @param $name
     * @param $arguments
     * @return mixed
     */
    public function __call($name, $arguments) {
        return call_user_func_array(array($this->templateObject, $name), $arguments);
    }

}