<?php

/**
 * Smarty plugin
 * -------------------------------------------------------------
 * File:     function.price.php
 * Type:     function
 * Name:     price
 * Purpose:  outputs price
 * -------------------------------------------------------------
 */

function smarty_function_price($params, Smarty_Internal_Template $template)
{
    $boutique = Boutique::getInstance();
    $price = 0;
    $type = null;
    if(!isset($params["notag"])){
        $params["notag"] = true;
    }

    if (isset($params['ht']) && isset($params['ttc'])) {

        $session = Application::getCurrentRequest()->getSession();
        $params['tva'] = ($session->has('display_price') && $session->get('display_price') == 'ht') ? 0 : 1;

        if (isset($params['tva'])) {
            $price = ($params['tva'] == 1) ? $params['ttc'] : $params['ht'];
            $type = ($params['tva'] == 1) ? 'ttc' : 'ht';
        } else {
            $price = ($boutique->tva == 1) ? $params['ttc'] : $params['ht'];
            $type = ($boutique->tva == 1) ? 'ttc' : 'ht';
        }
    } else if(isset($params['tax'])) {
        $price = $params["tax"];
        $type = "";
    } else {
        if (isset($params['ht'])) {
            $price = $params['ht'];
            $type = 'ht';
        } elseif (isset($params['ttc'])) {
            $price = $params['ttc'];
            $type = 'ttc';
        }
    }

    if(isset($params["notag"])){
        $type = "";
    }

    if (isset($params["decorate"])) {
        $return = $boutique->getDevise()->format($price, $type, $params["decorate"]);
    } else {
        $return = $boutique->getDevise()->format($price, $type);
    }

    return $return;
}