<?php

/**
 * Smarty plugin
 * -------------------------------------------------------------
 * File:     function.render.php
 * Type:     function
 * Name:     render
 * Purpose:  render a controller / action
 * -------------------------------------------------------------
 */

/**
 * @param $params
 * @param Smarty_Internal_Template $template
 *
 * @return string
 */
function smarty_function_render($params, Smarty_Internal_Template $template) {

    $request = Application::getCurrentRequest();

    if (empty($params['controller']) || empty($params['action'])) {
        return '';
    }

    $keyExclude = array("controller" => "", "action" => "");
    $attributes = array_diff_key($params, $keyExclude);

    $request->attributes->add($attributes);

    /** @var \Symfony\Component\HttpFoundation\Response $response */
    $response = call_user_func_array(array(new $params['controller']($request), $params['action']), array());
    return $response->getContent();
}